
function file(){
	//initialize file object (location: profile directory)
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("ProfD", Components.interfaces.nsIFile);

	file.append("index"); //folder named 'index'

	if(!file.exists() || !file.isDirectory()) 
		file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
		
	return file;
}

function write(){
	var f = file();

	//initialize xpcom
	var writer = Components.classes["@bookmarktools.mozdev.org/search/indexWriter;1"].createInstance();
	writer = writer.QueryInterface(Components.interfaces.ICLWriter);

	//set path
	writer.setPath(f.path);

	//create index document
	for(var i = 0 ;i < 3; i++){
		var cl_document = new Object();
		cl_document.primaryKey = "key" + i;						//this shoud be a unique key
		cl_document.name = "first document" + i;					//document name
		cl_document.content = "Hello World " + i;					//some content

		//append document
		writer.appendDocument(
			cl_document.primaryKey,
			cl_document.name,
			cl_document.content
		);
	}

	//optimize data
	writer.optimize();
}

function read(){
	var f = file();

	//initialize xpcom
	var reader = Components.classes["@bookmarktools.mozdev.org/search/indexReader;1"].createInstance();
	reader = reader.QueryInterface(Components.interfaces.ICLReader);

	//set path
	reader.setPath(f.path); //see section 'Writing'

	var results = Components.classes["@mozilla.org/array;1"]
					.createInstance(Components.interfaces.nsIMutableArray);
	reader.lookup(results);

	var e = results.enumerate();
	while (e.hasMoreElements()) {
		var lookupNode = e.getNext().QueryInterface(Components.interfaces.ILookupNode);
		
		//Object: lookupNode
		//-> lookupNode.primaryKey
		//-> lookupNode.name
		alert(lookupNode.primaryKey + "\n" + lookupNode.name);
	}
}

function update2(){
	var f = file();

	//initialize xpcom
	var writer = Components.classes["@bookmarktools.mozdev.org/search/indexWriter;1"].createInstance();
	writer = writer.QueryInterface(Components.interfaces.ICLWriter);

	//set path
	writer.setPath(f.path);

	//create index document
	var cl_document = new Object();
	cl_document.primaryKey = "key66";						//this shoud be a unique key
	cl_document.name = "first document66";					//document name
	cl_document.content = "Hello World! 66";					//some content

	//append document
	writer.updateDocument(
		1,
		cl_document.primaryKey,
		cl_document.name,
		cl_document.content
	);

	//optimize data
	writer.optimize();
}

function run(){

}

