/*
	Simple term highlighter, developed @ http://eriwen.com/javascript/highlight-search-results-with-js/  (16.04.2009)
*/

function highlight(searchTerms, textContainerNode) {
	for (var i in searchTerms) 	{
		// The regex is the secret, it prevents text within tag declarations to be affected
		if(!i.trim().empty()){
			var regex = new RegExp(">([^<]*)?("+searchTerms[i]+")([^>]*)?<","ig");
			highlightTextNodes(textContainerNode, regex, i);
		}
	}
}

function highlightTextNodes(element, regex, termid) {
	var tempinnerHTML = element.innerHTML;
	// Do regex replace
	// Inject span with class of 'highlighted termX' for google style highlighting
	element.innerHTML = tempinnerHTML.replace(regex,'>$1<span style="color: red; font-size: 20px;">$2</span>$3<');
}